#include <avr/pgmspace.h>
#include <avr/interrupt.h>

#include <util/delay.h>
#include "utils.h"
#include "low_lcd.h"
#include "logo_screen.h"


#define LED1_OFF PORTD &= ~(1 << 1);
#define LED1_ON  PORTD |=  (1 << 1);
#define LED2_OFF PORTD &= ~(1 << 2);
#define LED2_ON  PORTD |=  (1 << 2);


int main(void)
{
	// Initialize the ports
	Initialize_GPIO();
    // Initialize timers, PWMs, and LCD
	Initialize_contrast_backlight_and_LCD();

	while(1)
	{
		InitializeLCD();
		UpdateLCD();
		for(int i=0;i<40;i++)
			_delay_us(100000);

		show_text();
		for(int i=0;i<40;i++)
			_delay_us(100000);

		show_chinese_text();
		for(int i=0;i<40;i++)
			_delay_us(100000);

	}
	return 0;
}

