 //============================================================================
// CFA-10000-12864A-C Demonstration code
// TIMER.C: Timer setup and control
// Samsung KS0107+KS0108 (S6B0107+S6B0108) LCD Controller
// Atmel ATMega32 processor @ 16MHz
// WinAVR / AVR GCC + Atmel AVR Studio
// Written by Brent A. Crosby
// Copyright 2005, Crystalfontz America, Inc. http://www.crystalfontz.com
//============================================================================
#include <avr/io.h>
#include <avr/interrupt.h>
#include "utils.h"
#include "timer.h"



void Initialize_And_Start_Timer_0_LCD_Contrast_PWM(void)
  {
  //Stop the timer for now.
  TCCR0A=0x00;

  //Make sure the interrupt is disabled.
  TIMSK0=0;

  //Reset the hardware timer count. The timer is stopped.
  TCNT0=0;
  //Set the compare to 112.
  OCR0A=112;
  //Enable the counter.
  //  16MHz/1 = 16,000,000Hz
  //  16,000,000/64 = 250,000Hz
     TCCR0A = (1 << WGM00) | (1 << COM0A1);
 //    TCCR0B = (1 << CS00) | (1 << CS01);
     TCCR0B = (1 << CS01);
  }
//============================================================================
void Initialize_And_Start_Timer_1_32_Hz_and_Backlight(void)
  {
  //Stop the timer for now.
  TCCR1A=0x00;
  TCCR1B=0x00;

  //Make sure the interrupt is disabled
  TIMSK1=0;

  //Reset the hardware timer count. The timer is stopped.
  TCNT1=0;

  //Set the compare to 255 = 100%, LCD backlight is on.
  OCR1A=255;

// TCCR1A:
// COM1A1 COM1A0 COM1B1 COM1B0 COM1C1 COM1C0 WGM11 WGM10
//    0      1      0      0      0      0     0     1
  //Enable the counter.
  TCCR1A = (1 << WGM10) | (1 << COM1A1);
  TCCR1B = (1 << CS12) | (1 << CS10) | (1 << WGM12);


  }
//============================================================================
void Initialize_And_Start_Timer_2_32_Hz_and_Backlight(void)
  {
  //Stop the timer for now.
  TCCR2A=0x00;
  TCCR2B=0x00;

  //Make sure the interrupt is disabled
  TIMSK2=0;

  //Reset the hardware timer count. The timer is stopped.
  TCNT2=0;

  //Set the compare to 255 = 100%, LCD backlight is on.
  OCR2A=255;

// TCCR1A:
// COM1A1 COM1A0 COM1B1 COM1B0 COM1C1 COM1C0 WGM11 WGM10
//    0      1      0      0      0      0     0     1
  //Enable the counter.
  TCCR2A = (1 << WGM20) | (1 << WGM21) | (1 << COM2A1);
  TCCR2B = (1 << CS22) | (1 << CS21) | (1 << CS20);


  }
//============================================================================
void Initialize_And_Start_Timer_3_32_Hz_and_Backlight(void)
  {
  //Stop the timer for now.
  TCCR3A=0x00;
  TCCR3B=0x00;

  //Make sure the interrupt is disabled.
  TIMSK3=0;

  //Reset the hardware timer count. The timer is stopped.
  TCNT3=0;

  //Set the compare to 255 = 100%, LCD backlight is on.
  OCR3A=255;

// TCCR1A:
// COM1A1 COM1A0 COM1B1 COM1B0 COM1C1 COM1C0 WGM11 WGM10
//    0      1      0      0      0      0     0     1
  //Enable the counter.
  TCCR3A = (1 << WGM30) | (1 << COM3A1);
  TCCR3B = (1 << CS32) | (1 << CS30) | (1 << WGM32);


  }
//============================================================================
//----------------------------------------------------------------------------
//#pragma vector=TIMER1_COMPA_vect
/*
ISR(TIMER5_COMPA_vect)
  {
  Keyboard_Poll_Timer--;
	inactivity_pacer++;
  if(!(inactivity_pacer&0x07))
  	if(inactivity_timer)
	    inactivity_timer--;
  if(ad_pacer)
    ad_pacer--;
  if(march_pacer)
    march_pacer--;
  }

*/
