
#ifndef __UTILS_H_
#define __UTILS_H_

//============================================================================
//PORTA is the LCD data.
#define LCD_DATA_PORT               PORTA
#define LCD_DATA_PINS               PINA
#define LCD_DATA_DDR                DDRA
#define LCD_DATA_ALL_INPUTS         0x00
#define LCD_DATA_ALL_OUTPUTS        0xff

#define LCD_DATA_BUSY_LSB                   7
#define LCD_DATA_BUSY_FIELD_LEN             1
#define LCD_DATA_BUSY_MASK                  (((1 << LCD_DATA_BUSY_FIELD_LEN) - 1) << LCD_DATA_BUSY_LSB)
#define LCD_DATA_BUSY_GET(LCD_DATA_WORD)    (((LCD_DATA_WORD) & LCD_DATA_BUSY_MASK) >> LCD_DATA_BUSY_LSB)
#define LCD_DATA_BUSY_PUT(LCD_DATA_WORD)    (((LCD_DATA_WORD) << LCD_DATA_BUSY_LSB) & LCD_DATA_BUSY_MASK)

//============================================================================
#define LCD_CONTRAST_PORT           PORTB
#define LCD_CONTRAST_DDR            DDRB
#define LCD_CONTRAST_PWM            PB7
#define LCD_BL_RED                  PB5
#define LCD_BL_K                    PB5
#define LCD_BL_BLU                  PB4
#define MISO                        PB3
#define MOSI                        PB2
#define SCK                         PB1
#define SS                          PB0

//============================================================================
#define LCD_CTRL_PORT               PORTC
#define LCD_CTRL_DDR                DDRC

#define LCD_DI                      PC7
#define LCD_RW                      PC6
#define LCD_E                       PC5
#define LCD_CS1                     PC4
#define LCD_CS2                     PC3
#define LCD_RST                     PC2
#define LCD_CS3                     PC1

//============================================================================
#define KEY_PORT                    PORTD
#define KEY_PINS                    PIND
#define KEY_DDR                     DDRD

#define KEY0                        0x10
#define KEY1                        0x20
#define KEY2                        0x40
#define KEY3                        0x80

//============================================================================
#define LCD_GRN_CONTRAST_PORT       PORTE
#define LCD_GRN_CONTRAST_DDR        DDRE

#define LCD_BL_GRN                  PE3

//============================================================================
#define LCD_EL_PORT                 PORTG
#define LCD_EL_DDR                  DDRG

#define LCD_EL                      PG4

//============================================================================
#define CLR_E                       LCD_CTRL_PORT &= ~(1 << LCD_E);
#define SET_E                       LCD_CTRL_PORT |= (1 << LCD_E);

#define CLR_CS1                     LCD_CTRL_PORT &= ~(1 << LCD_CS1);
#define SET_CS1                     LCD_CTRL_PORT |= (1 << LCD_CS1);

#define CLR_CS2                     LCD_CTRL_PORT &= ~(1 << LCD_CS2);
#define SET_CS2                     LCD_CTRL_PORT |= (1 << LCD_CS2);

#define CLR_RW                      LCD_CTRL_PORT &= ~(1 << LCD_RW);
#define SET_RW                      LCD_CTRL_PORT |= (1 << LCD_RW);

#define CLR_RS                      LCD_CTRL_PORT &= ~(1 << LCD_DI);
#define SET_RS                      LCD_CTRL_PORT |= (1 << LCD_DI);

#define CLR_RESET                   LCD_CTRL_PORT &= ~(1 << LCD_RST);
#define SET_RESET                   LCD_CTRL_PORT |= (1 << LCD_RST);


//============================================================================
/* Function prototypes
 */
void Initialize_GPIO(void);
void update_contrast(unsigned char contrast);
void update_backlight_R(unsigned char backlight);
void update_backlight_G(unsigned char backlight);
void update_backlight_B(unsigned char backlight);
void Initialize_contrast_backlight_and_LCD();


#endif
